<?php
/**
 * api: genericplugins
 * type: application
 * priority: never
 * depends: upgrade, admin_ui, vs.unzip
 * title: Pluginstaller
 * description: Allows to install plugins/packages from remote server list.
 * license: XVGPL 0.2
 * version: 0.5
 *
 *
 * THIS IS UNFINISHED. BUT CAN PROBABLY BE PUT TO USE ALREADY.
 *
 *
 * Copys uploaded plugins or packages into a writable plugin directory (if
 * available). Or retrieves list from remote server, and installs selected
 * packages locally.
 *
 * Plugins are single .php scripts, and packages are .zip files containing
 * multiple of them, or additional data files. The term "module" is used
 * for huger packages, which represent an application (part) of their own.
 *
 * Beware that plugin repositories are trusted and no further security
 * checks are made. And once installed plugins run with local privileges
 * anyhow.
 * THE "VERIFIED" CERTIFICATE OF PLUGINS DOES NOT GUARANTEE
 * SECURE CODE OR ANY TRUST LEVEL WHATSOVER. USE AT OWN RISK.
 *
 * This implementation recognizes type:install plugins in .zip archives,
 * and executes them after unpacking with the constant "INSTALL" set. This
 * is no generic procedure, and might not work for every plugin api: and
 * type.
 *
 * We expect clean package data from the repositories. If that data is
 * quirky (for ZIP archives), we have more work to do here and potentially
 * yield incorrect warning messages. Inner dependencies should be removed
 * already and the main plugin in a zip plugin package should return all
 * meta description and config infos.
 *
 */
 


/**
 * URLs with package/plugin data in PHP serialize()d format. Its format is
 * just an array of plugin meta data entries, possibly augmented by further
 * repository descriptions.
 *
 *  [ id, title, description, download_url, version, category, priority,
 *    url, author, author_url, license, help, depends, icon, api, type,
 *    verified, user_votes, download_count, ...                          ]
 *
 * At least title and download_url have to be present, of course.
 *
 */
$PLUGINSTALL_SOURCES = array(
   //"./repository.dat.local",
   "http://milki.erphesfurt.de/genericplugins//repository.dat.php",
   //"http://www.example.com/plugins/list.php-serialized",
); 


/**
 * Where to extract/upload new plugins to per default. Allows us to give
 * a warning if this directory isn't writable, and instead present a link
 * for manual download.
 *
 */
$PLUGINSTALL_DIR = "./plugins/var";


/**
 * Constants for filenames, URL parameters, etc.
 *
 */
define("PLUGINSTALL_SOURCES_LIST", "sources.list");
define("PLUGINSTALL_CACHE", "repository.cache");
define("PLUGINSTALL_UP_UPLOAD", "upload");
define("PLUGINSTALL_UP_ADDREP", "new_repository");




/**
 * Main code.
 * MUST BE ADAPTED to point to the real admin_ui script.
 *
 *
 * @param  object  libconfig instance to reset and use
 *
 */
function pluginstall(&$conf) {
   global $PLUGINSTALL_DIR, $PLUGINSTALL_SOURCES;


   #-- get available plugins from repositories - cached
   echo '<div class="error-box" style="max-height:120px; overflow:scroll; margin-bottom: 15px">';
   $pkgs = pluginstall_get_repository_cached();
   echo '</div>';




   #-- direct form to ourselves
   echo "<form action=\"$_SERVER[REQUEST_URI]\" method=\"POST\" enctype=\"multipart/form-data\" accept-encoding=\"utf-8\">";

   
   #-- actually install plugins
   if ($_REQUEST["install"]) {
   
      /**
       *  @NOTE: Package interdependency handling is rather light here.
       *  Not many plugins will use it anyhow (YAGNI), so we just cover
       *  the basics and leave warning messages to the local config mngr.
       *  (Else too much duplicated functionality here.)
       *  No care is taken for manually uploaded plugins. So users might
       *  face warning messages also manually then, like with dpkg ;-)
       */       

      // mundane dependency resolution
      pluginstall_add_dependencies($_REQUEST["install_by_id"], $pkgs, $conf->pmd->plugin);

      // download plugins and extract packages, return list of installed filenames
      $extracted_files = (array)pluginstall_from_list($_REQUEST["install_by_id"], $pkgs);
      
      // and/or a manual upload?
      if (isset($_FILES["upload"]) and ($temp = $_FILES["upload"]["tmp_name"])
      and ($temp_id = strtok(basename($_FILES["upload"]["name"]), ".")) )
      {
         $extracted_files = $extracted_files + (array)pluginstall_from_file($temp, $temp_id);
      }


      // find out which of the new files are actually *.php plugins
      $newplugins = pluginstall_newplugins($extracted_files);
      
      // execute any new type:install plugins
      pluginstall_exec_installers($newplugins);
      
      
      // reread config and plugin meta data
      $conf = new generic_config_html(CONFIG_DIR, CONFIG_FILE);
      
      // pre-enable new plugins
      foreach ($newplugins as $id=>$row) {
         $conf->assign($id, 1);
      }
      $conf->save();


      // display form for new plugins & settings
      ?>
        <form action="admin_ui.php" method="POST" enctype="multipart/form-data" accept-encoding="utf-8">
      <?
      foreach ($newplugins as $id=>$row) {
         echo $conf->html($row);
         foreach ((array)$row->config as $se) {
            echo $conf->html($se);
         }
      }
      ?>
        <input type="submit" name="save" value="Update settings for new plugins">
      <?
      

      // alternative/mixed-in action: - add a new plugin repository?
      if (isset($_REQUEST["new_repository"])) {
         pluginstall_add_repository($_REQUEST["new_repository"]);
         echo "<div class=\"message\">New repository added.</div>";
      }

   }
   
   #-- show pkg manager
   else {

      // save plugin settings after installation step 2
      if ($_REQUEST["save"]) {
         $conf->form_receive();
         // and proceed...
      }

      // show pkgman/installer UI
      pluginstall_show_pkgman($pkgs, $conf->pmd->plugin);

   }
   echo "</form>";

}



/**
 * Check for actual plugins in a list of filenames.
 *
 */
function pluginstall_newplugins($newfiles) {
   $pmd = new generic_pmd();
   $newplugins = array();
   foreach ($newfiles as $fn) {
      if (strpos($fn, ".php") && ($id = basename($fn, ".php")) && ($row = $pmd->read($fn))) {
         $row["id"] = $id;
         $row["fn"] = $fn;
         $newplugins[$id] = $row;
      }
   }
   return $newplugins;
}



/**
 * Run plugins with a type: or api: of "install", or if they're called *.install.php
 *
 * @BUG: This is application-specific. Not all package types and API:s will
 * use this scheme. It's too simplistic for a general approach and probably
 * has to be adapted per application.
 *
 */
function pluginstall_exec_installers(&$newplugins) {
   define("IN_INSTALL", 1);
   define("INSTALL", 1);
   foreach ($newplugins as $id=>$row) {
      if ($row["api"]=="install" || $row["type"]=="install" || strpos($fn, ".install.")) {
         unset($newplugins[$id]);
         // execute it
         include_once($row["fn"]);
      }
      if ($row["api"]=="uninstall" || $row["type"]=="uninstall" || strpos($fn, ".uninstall.")) {
         unset($newplugins[$id]);
      }
   }
}



/**
 * Get available-plugin/package data from cache, or initiate repository query.
 *
 */
function pluginstall_get_repository_cached($force=0, $caching=1) {
   global $PLUGINSTALL_DIR, $PLUGINSTALL_SOURCES;

   // check dir / find writable
   pluginstall_writable();
   
   // data dir and files
   $cache = $PLUGINSTALL_DIR."/".PLUGINSTALL_CACHE;
   $user_repositories = $PLUGINSTALL_DIR."/".PLUGINSTALL_SOURCES_LIST;
   $PLUGINSTALL_SOURCES = $PLUGINSTALL_SOURCES + (array)@file($user_repositories);
   
   // fetch fresh?
   if ($force || $_REQUEST["update_rep"] || !file_exists($cache) || (time() > filemtime($cache) + 60*60)) {
      // get
      $pkgs = pluginstall_get_repository($force, $cache);
      // save?
      if ($pkgs && $caching) {
         @file_put_contents($cache, serialize($pkgs));
      }
   }
   // from cache
   else {
      $pkgs = unserialize(file_get_contents($cache));
   }
   
   return($pkgs);
}



/**
 * Add URL to sources.list.
 *
 */
function pluginstall_add_repository($url) {

   // add a new repository?
   if ($url && preg_match("#^http://\w+#", $url) and ($html = @file_get_contents($url)))
   {
      // get real repo-URL
      if (@unserialize($html)) {
         $url = $url;
      }
      elseif (preg_match('/<link\s+rel="[^">]*?plugin[^">]*"\s+href="(.+?)"/', $html, $uu)) {
         $url = $uu[1];
      }
      else {
         return;
      }
   
      // add
      if ($f = fopen($GLOBALS["PLUGINSTALL_DIR"]."/".PLUGINSTALL_SOURCES_LIST, "a+")) {
         fwrite($f, $url . "\n");
         fclose($f);
         // update cache
         return pluginstall_get_repository(1);
      }
   }
   
}



/**
 * Assemble list of available plugins. Fetches meta data lists from plugin
 * repositories.
 *
 * @return  array   (id => plugin meta info)
 */
function pluginstall_get_repository() {
   $plugins = array();

   // check each repository
   foreach ($GLOBALS["PLUGINSTALL_SOURCES"] as $i=>$url) if ($url = trim($url)) {
   
      // prepare HTTP query
      ini_set("allow_url_fopen", true);
      #ini_set("http_accept", "application/php-serialized, */*;q=0.01");
   
      // try to fetch PHP serialize()d data block
      if ($dat = @file_get_contents($url)) {
         $add = array();
      
         // try to decompress (if PHP didn't handle HTTP Content-Encoding)
         if (!function_exists("gzinflate")) {
         }
         // +gzip
         elseif (strncmp($dat, "\037\213", 2) == 0) {
            if (function_exists("gzdecode")) {
               $dat =  gzdecode($dat);
            }
            else {
               ($b = strpos($dat, "\335Z")) and ($b<100) or ($b=10);
               $dat = gzinflate(substr($dat, $b, strlen($dat)-8-$b));
            }
         }
         // +deflate
         elseif (strncmp($dat, "a:", 2) != 0) {
            if (@gzinflate($add)) {
               $dat = gzinflate($dat);
            }
         }
      
         // is raw PHP array
         if ($add = @unserialize($dat)) {
            is_array($add) || ($add = array());
         }
         // should we otherwise add *.php/*.zip HTML links as possible plugins?
         elseif (preg_match("/Directory Index/i", $dat)) {
            preg_match_all("/<a href=\"(([^\/\">]+?)\.(php|zip))\"/", $dat, $uu);
            foreach ($uu[1] as $i=>$fn) {
               $id = $uu[2][$i];
#<off>#               $plugins[] = array("id"=>$id, "title"=>$fn, "download_url"=>"$url/$fn", "category"=>"else", "priority"=>"rare");
            }
         }
         else {
            echo "<!-- X-Empty-Repository-$i: $url -->\n";
         }
      }
      else {
         echo "<!-- X-Broken-Repository-$i: $url -->\n";
      }
      
      // append to list
      foreach ((array)$add as $row) {
         if (isset($plugins[$row["id"]])) {
            pluginstall_error("A plugin by the name '".htmlentities($row["id"])."' exists in multiple repositories or even twice.");
         }
         else {
            $plugins[$row["id"]] = $row;
         }
      }
   }
   
   return $plugins;
}



/**
 * Recursive htmlentities(), collapse sub-arrays to , lists.
 *
 */
function html_array(&$A, $collapse=0) {
   foreach ($A as $i=>$text) {
      if (is_array($text)) {
         $text = html_array($A, 1);
         $text = implode(", ", $text);
      }
      $A[$i] = htmlentities($text);
   }
}



/**
 * Augment package installation $list by inner dependencies. Checks if
 * dependend packages exist on the local system, or if they else can be
 * retrieved from the repository as well.
 * (If the package repository data isn't consolidated correctly it will
 * show us incorrect dependencies - zip packages with inner depends:,
 * that actually didn't have to be handled here.)
 *
 * @param &array         list of to-be-installed pkgs
 * @param  array         repository packages
 * @param  array         locally present plugins/pkgs
 * @return &
 * @output
 */
function pluginstall_add_dependencies(&$install_list, $from_remote, $available_locally) {
   foreach ((array)$install_list as $id) {
      if ($dependencies = @$from_remote[$id]["depends"]) {
         foreach (split("\s*,\s*", $dependencies) as $requ_pkg) {
            // already present locally, or available from remote?
            if (!$available_locally[$requ_pkg] && $from_remote[$requ_pkg]) {
               $list[] = $requ_pkg;   // then add it
               // @BUG: what about sub-sub-sub-sub-dependencies?
            }
            else {
               // This will yield an error message later on, but we allow the
               // downloading to proceed nevertheless.
               // Moreover we couldn't handle virtual dependencies here anyhow.
               echo "<!-- missed download dependency: $requ_pkg -->\n";
            }
         }
      }
   }
   $install_list = array_unique((array)$install_list);
}


/**
 * Evaluates $__REQEUST[install_by_id][] list from submit form.
 *
 * @param  array $_REQUEST  form GET/POST data
 * @param  array $plugins   already installed plugins
 * @return array            list of extracted filenames
 */
function pluginstall_from_list(&$install_list, $plugins) {

   // loop through POST request
   foreach ((array)$install_list as $id) {
#      if (!$yes) {      }
      // ooops, shouldn't happen
      if (!$plugins[$id]) {
         pluginstall_error("plugin '$id' not in known repostiories (caching error? internal pluginstaller bug?)");
      }
      // no direct-download location
      elseif (!strlen($url = $plugins[$id]["download_url"]))  {
         pluginstall_error("The package '$id' has no direct download_url specified. Cannot retrieve it.");
      }
      // ok, finally
      else {
         return pluginstall_from_url($url, $id);
      }
   }
}



/**
 * Download a plugin/package.
 *
 */
function pluginstall_from_url($url, $id) {
   $temp = tempnam("/tmp/sys.dir.....", "pkgm");
   if ($data = @file_get_contents($url)) {
      if (file_put_contents($temp, $data)) {
         return pluginstall_from_file($temp, $id);
      }
      else {
         pluginstall_error("Error creating temporary file for downloaded package.");
      }
   }
   else {
      pluginstall_error("Couldn't download plugin/package from '$url'");
   }
}



/**
 * Save or unpack a plugin/package.
 *
 * //@SECURITY: We do not work around plugin ids or contained package filenames
 * containing malicious characters, because plugin code will be executed anyhow.
 * It's pointless to check for filenames while unpacking unverified code.
 *
 */
function pluginstall_from_file($fn, $id) {
   global $PLUGINSTALL_DIR;
   $filelist = array();

   // check install destination directory first
   //@FIX: pretty late for that, should error out before downloading (-> just move to _from_request() or main)
   if (!pluginstall_writable()) {
      pluginstall_error("Plugin cannot be installed, because destination directory ($PLUGINSTALL_DIR) isn't writable.");
      return;
   }
   
   // get first 16 byte, for file magic check
   $f = fopen($fn, "rb");
   $data = fread($f, 4);
   fclose($f);

   // looks like a zip file
   if ($data == "PK\003\004") {
   
      // open Archive
      if (!class_exists("vsUnzipFile")) {
         include_once("lib/vs.unzip.php");
      }
      $zip = new vsUnzipFile();
      $zip->open($fn);
      
      // check for common subdir name
      if ($pfix = pluginstall_commonbasedir($zip->names)) {
         $dir = realpath($PLUGINSTALL_DIR);
      }
      // else use supplied package basename
      else {
         $dir = realpath("$PLUGINSTALL_DIR/$id");
         @mkdir($dir);
      }
      
      // create files & subdirectories
      foreach ($zip->names as $file) {
         @mkdir(dirname("$dir/$file"));
         file_put_contents("$dir/$file", $zip->get_data($file));
         $filelist[] = "$dir/$file";
      }
   } 
   
   // ordinary .php script
   elseif ($data == "<?ph") {
   
      if (file_exists($dest = "$PLUGINSTALL_DIR/$id.php")) {
         // probably an update, so don't care
      }
      
      // cp
      if (copy($fn, $dest)) {
         $filelist[] = $dest;
      }
   }

   // what is it?
   else {
      pluginstall_error("Cannot install. Unrecognized plugin format.");
   }

   // needed to read in plugin meta data and display setup screen after unpacking
   return( $filelist );
}



/**
 * Check if filenames all contain a common subdir/ prefix, return it.
 *
 */
function pluginstall_commonbasedir($filenames) {
   $pfix = "";
   $first = $filenames[0];
   if (strpos($first, "/")) {
      $pfix = strtok($first, "/");
      foreach ($filenames as $n) {
         if ($pfix != strtok($n, "/")) {
            $pfix = "";
            break;
         }
      }
   }
   return $pfix;
}



/**
 * Test if configured destination directory is writable.
 * (Or make up a new...)
 *
 */
function pluginstall_writable() {
   global $PLUGINSTALL_DIR;

   // check main dir
   if (is_writable($PLUGINSTALL_DIR)) {
      is_dir($PLUGINSTALL_DIR) || mkdir($PLUGINSTALL_DIR); // for errormsg if it's an ordinary file
      return TRUE;
   }

   // test alternatives
   else {
      $fallback = array(
         $PLUGINSTALL_DIR,
         "./var/plugins",
         "./local/plugins",
         "./plugins/var",
         "./plugins/local",
         "./include/var",
      );
      foreach ($fallback as $dir) {
         if (is_writable($dir) || is_writable($dir=dirname($dir)) && mkdir($dir)) {
            $PLUGINSTALL_DIR = $dir;
            return TRUE;
         }
      }

      // else do a local directory search?
      // not good, too undeterministic
   }
   return FALSE;
}




/**
 * Display HTML chooser list for all available plugins.
 *
 * @param  array          simple enumerated repository list
 * @param  array          id-indexed list of installed plugins
 * @output
 */
function pluginstall_show_chooser($plugins, $installed=array()) {
   $defaults = array("icon"=>"img/plugin.png", "category"=>"else", "priority"=>"rare", "help"=>"no help available", "license"=>"no license specified", "author"=>"unknown");
   $writable = pluginstall_writable();
   
   // loop
   foreach ($plugins as $p) {
   
      // prepare for output
      $p = (array)$p + $defaults;
      html_array($p);  // recursive htmlentities()
      $id = $p["id"];
      
      // additional flags
      $flags = "";
      $install = "install";
      $download = "download";
      // new version?
      if (version_compare(@$p["version"], @$installed[$id]["version"]) >= 1) {
         $flags .= " new-version";
         $install = "<b>update</b>";
      }
      elseif (isset($installed[$id])) {
         $flags .= " have-installed";
         $install = "reinstall";
      }
      // download
      if (!$writable) {
         $install = "<del>$install</del>";
      }
      if (!$p["download_url"]) {
         $download = "<del>$download</del>";
      }
      // cert
      if (@$p["verified"]) {
         $cert = "<img src=\"img/certified.png\" align=\"left\" width=\"16\" height=\"16\" alt=\"examined/verified\" />";
      }
      else {
         $cert = "";
         $flags .= " not-approved";
      }

      // uniform html block
      ?>

      <div id="plugin_id_<?= $id ?>" class="plugin  category-<?= $p['category'] ?>  priority-<?= $p['priority'] ?>  <?= $flags ?>" onClick="show_more('<?= $id ?>');">
        <div class="action-box">
          <a class="install-link" href="javascript:install_immediately('<?= $id ?>');"><?=$install?></a>
          <a href="<?= $p['download_url'] ?>"><?=$download?></a>
          <!--a href="javascript:show_more('<?= $id ?>');">more info</a-->
          <!--br/><a href="javascript:preconfig('<?= $id ?>');">preconfig</a-->
        </div>
        <div class="base-info">
          <label for="select_id_<?= $id ?>">
            <span class="install-checkbox"><input type="checkbox" name="install_by_id[]" value="<?= $id ?>" id="select_id_<?= $id ?>" /></span>
            <img class="icon" src="<?= $p['icon'] ?>" width="32" height="32" align="left" alt="<?= $id ?>" hspace="2" border="0" />
            <h4 class="title" title="<?= $id ?>"><?= $p["title"] ?></h4>
            <span class="version"><?= $p["version"] ?></span>
          </label>
          <div class="description"><?= $p["description"] ?></div>
          <span class="author">by <?= $p["author"] ?></span>
          <span class="url"><?= $p["url"] ? "| <a href=\"$p[url]\">plugin homepage</a>" : "" ?></span>
          <span class="verified"><?= $cert ?></span>
        </div>
        <div class="extended-info">
          <div class="help"><?= nl2br($p["help"]) ?><br/><br/></div>
          <?
             // list all fields
             unset($p["help"]);
             foreach ($p as $name=>$text) {
                $name = htmlentities($name);
                echo "<div class=\"field\">$name: <span class=\"fielddata f-$name\">$text</span></div>\n";
             }
          ?>
        </div>
        <!--div class="pre-config"> $conf->html($conf->pmd->config[$id][])  </div-->
      </div>

      <?php
   }
}



/**
 * Package manager (like gnome-app-install / synaptic) with AJAX super cow
 * powers.
 *
 * @BUG: Yes, it uses a presentational <table>. But I gave up on IE..
 *
 * @param array $pmd    installable plugins from repositories
 * @param array $have   locally present plugin list
 * @output 
 */
function pluginstall_show_pkgman($pmd, $have) {

   ?>
   <div id="package_manager_window">
   <div id="package_manager">
   <h3>Plugin and Package Installation Manager</h3>
   
   <table border="0" cellpadding="0" cellspacing="0" summary="window/pane layout">
   <colgroup><col width="140" /><col width="560" /></colgroup>
   
   <tr><td colspan="2">
   <div id="controlbuttons">
     <select name="x2">
        <option onClick="jQuery('.plugin.have-installed').hide();">show only new packages</option>
        <option onClick="jQuery('.plugin').show();">available and installed plugins</option>
        <option onClick="jQuery('.plugin.priority-never, .plugin.priority-auto').hide();">hide dependencies</option>
        <option onClick="jQuery('.plugin.api-php').show();">only generic PHP plugins</option>
        <option onClick="jQuery('.plugin.api-ewiki').show();">ewiki plugins</option>
        <option onClick="jQuery('.plugin.api-ubuntu').show();">only Ubuntu Applications</option>
     </select>
   </div>
   </td></tr>
   
   <tr>
   <td valign="top" rowspan="2">
   <div id="categorylist">
   <?
     foreach (pluginstall_categories($pmd) as $cat=>$title) {
        echo "<a id=\"category_$cat\" href=\"javascript:show_category('$cat');\"><img src=\"img/$cat.png\" width=\"16\" height=\"16\" align=\"middle\" /> $title</a>\n";
     }
   ?>
    <a class="selected" id="category_" href="javascript:show_category('');"><img src="img/all.png" width="16" height="16" align="middle" /> All</a>
   </div>
   </td>

   <td>
   <div id="pluginlist">
   <?
     pluginstall_show_chooser($pmd, $have);
   ?>
   </div>
   </td>
   </tr>
   

   <tr>
   <td>
   <div id="detailpane">
      <div class="help">
      Select installable packages in the list above. They can be installed
      with the submit button, or individually with the 'install' link.
      <?
        if (!pluginstall_writable()) {
           echo '<div class="message error">Your plugin installation directory
           (<tt>' . $GLOBALS["PLUGINSTALL_DIR"] . '</tt>)
           is <em>not writable</em> currently. Either "<tt>chmod 777</tt>" it
           in your FTP or shell account,
           or else download and install the plugins manually.</div>';
        }
      ?>
      </div>
   </div>
   </td>
   </tr>
   
   <tr>
   <td>&nbsp;</td>
   <td>

   <input class="submit" type="submit" name="install" value="Install" onClick="submit_all()" style="float:right;" title="Download and install all selected packages and plugins from the repository to your webserver and application" />
   
   <input class="advanced" type="submit" name="upload" value="Upload a package..."
    onClick="$(this).attr('type','file').css({'padding':0}).attr('onClick',''); return false;"
    <? if (!pluginstall_writable()) { echo 'disabled="disabled"'; }  ?>
    title="Allows you to upload a package from your hard disk, not from a repository" />

   <input class="advanced" type="submit" name="new_repository" value="Add repository..."
    onClick="$(this).attr('type','text').attr('value','http://').css({'padding':0}).attr('onClick',''); return false;"
    <? if (!pluginstall_writable()) { echo 'disabled="disabled"'; }  ?>
    title="Adds package list from another PHP plugin standard repository" />


   </td></tr></table>
   </div>
   </div>
  
   <script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.4.2/jquery.min.js"></script>
   <script type="text/javascript">
   
     // eliminate window scroll borders immediately
     $("body").css({"overflow":"hidden"});
   
     /**
      * Make all .plugin entries visible right before submitting the
      * <form> - else browsers might not send all checkbox fields.
      * 
      */
     function submit_all() {
        $(".plugin").show();
     }
     

     /**
      * Select a .plugin list entry, highlight, and copy {help} text
      * into detail box.
      *
      */
     last_plugin = "";
     function show_more(id) {
        var plugin = $(".plugin#plugin_id_"+id);
        var detailpane = $("#detailpane");

        if (last_plugin) {
           //$(".plugin#plugin_id_"+)
           last_plugin.toggleClass("selected");
        }
        if (plugin) {
           last_plugin = plugin;
           plugin.toggleClass("selected");
        }
        detailpane.empty();
        plugin.children(".extended-info").clone().appendTo(detailpane);
     }
     
     
     /**
      * Change selection in category box, hide/show plugins accordingly.
      *
      */
     function show_category(cat) {
        if (cat) {
           $(".plugin").hide();
           $(".plugin.category-"+cat).show();
        }
        else {
           $(".plugin").show();
        }
        $("#categorylist a").removeClass("selected");
        $("#categorylist #category_"+cat).toggleClass("selected");
     }
     

   </script>
   
   <?

}


/**
 * Extract category names=>titles from plugin meta data list.
 *
 */
function pluginstall_categories($pmd) {
   $l = array();
   foreach ($pmd as $row) {
      $l[$row["category"]] = ucwords($row["category"]);
   }
   ksort($l);
   return($l);
}


/**
 * Output error message.
 *
 * @output
 */
function pluginstall_error($msg) {
   echo "<div class='message error'>$msg</div>";
}


?>